//+------------------------------------------------------------------+
//|                               Indicator: RSI_over_under_2022.mq4 |
//|                                       Created with EABuilder.com |
//|                                        https://www.eabuilder.com |
//+------------------------------------------------------------------+
#property copyright "Created with EABuilder.com"
#property link      "https://www.eabuilder.com"
#property version   "1.00"

#property indicator_separate_window
#property indicator_buffers 2

#property indicator_type1 DRAW_ARROW
#property indicator_width1 5
#property indicator_color1 0xEBBF49
#property indicator_label1 "Buy"

#property indicator_type2 DRAW_ARROW
#property indicator_width2 5
#property indicator_color2 0x4987EB
#property indicator_label2 "Sell"

//--- indicator buffers
double Buffer1[];
double Buffer2[];

extern int Period1 = 10;
extern int    over = 65;
extern int   under = 35;
double myPoint;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {   
   IndicatorBuffers(2);
   SetIndexBuffer(0, Buffer1);
   SetIndexEmptyValue(0, EMPTY_VALUE);
   SetIndexArrow(0, 110);
   SetIndexBuffer(1, Buffer2);
   SetIndexEmptyValue(1, EMPTY_VALUE);
   SetIndexArrow(1, 110);
   //initialize myPoint
   myPoint = Point();
   if(Digits() == 5 || Digits() == 3) myPoint *= 10;
   return(INIT_SUCCEEDED);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime& time[],
                const double& open[],
                const double& high[],
                const double& low[],
                const double& close[],
                const long& tick_volume[],
                const long& volume[],
                const int& spread[])
  {
   int limit = rates_total - prev_calculated;
   //--- counting from 0 to rates_total
   ArraySetAsSeries(Buffer1, true);
   ArraySetAsSeries(Buffer2, true);
   //--- initial zero
   if(prev_calculated < 1)
   {
      ArrayInitialize(Buffer1, EMPTY_VALUE);
      ArrayInitialize(Buffer2, EMPTY_VALUE);
   }
   else limit++;
   
   //--- main loop
   
   // limit bars must be minimum number of bars of highest timeframe being used to 'not repaint' 
   if (limit < PERIOD_M30 / _Period) limit=(PERIOD_M30 / _Period)+1;
   
   for(int i=limit-1; i>=0; i--)
   {
      if (i >= MathMin(5000-1, rates_total-1-50)) continue; //omit some old rates to prevent "Array out of range" or slow calculation   
      
      int barshift_M15 = iBarShift(Symbol(),PERIOD_M15,Time[i]); if (barshift_M15 < 0) continue;
      int barshift_M30 = iBarShift(Symbol(),PERIOD_M30,Time[i]); if (barshift_M30 < 0) continue;
      
      //Indicator Buffer 1
      if(iRSI(NULL, PERIOD_M15, Period1, PRICE_CLOSE, barshift_M15) >= over //Relative Strength Index >= fixed value
      || iRSI(NULL, PERIOD_M30, Period1, PRICE_CLOSE, barshift_M30) >= over //Relative Strength Index >= fixed value
      )
      {
         Buffer1[i] = 0; //Set indicator value at fixed value
      }
      else
      {
         Buffer1[i] = EMPTY_VALUE;
      }
      //Indicator Buffer 2
      if(iRSI(NULL, PERIOD_M15, Period1, PRICE_CLOSE, barshift_M15) <= under //Relative Strength Index <= fixed value
      || iRSI(NULL, PERIOD_M30, Period1, PRICE_CLOSE, barshift_M30) <= under //Relative Strength Index <= fixed value
      )
      {
         Buffer2[i] = 0; //Set indicator value at fixed value
      }
      else
      {
         Buffer2[i] = EMPTY_VALUE;
      }
   }
   return(rates_total);
}
//+------------------------------------------------------------------+

void myAlert(string type, string message)
{
   if(type == "print") Print(message);
   else if(type == "error")
   {
      Print(type+" | RSI_over_under_2022 @ "+Symbol()+","+IntegerToString(Period())+" | "+message);
   }
}
